//
//	Legato Code Examples
//	--------------------
//
//	Dialog Examples -- Combo Box Controls
//
//	Group:		Dialog
//	Title:		Combo Box Controls A (Simple)
//	Description:	Example of coding combo box style controls exhibiting various combo box features.
//	Revised:	12/16/2014
//
//	(c) Novaworks, LLC/PSG LLC
//

								/************************************************/

									/****************************************/
#include "ComboBox Controls 01.rc"					/* Resources				*/

								/************************************************/

									/****************************************/
									/* ** Prototypes			*/
	int 		combo_update			();		/* Our Support for Dialog Status	*/
									/*					*/
									/* ** Static Data			*/
	int		s_ix;						/* Persistent Select Index		*/


								/************************************************/

									/****************************************/
int main () {								/* Default Entry			*/
									/****************************************/
        int		rc;						/* Return Code				*/
									/*					*/        
	rc = DialogBox("ComboBoxTest01", "combo_");			/* Open the basic dialog		*/
	MessageBox('I', "Result 0x%08X", rc);				/* Display Returned Result		*/
	return ERROR_NONE;						/* Code not relavent			*/
	}								/* Just Leave				*/


								/************************************************/
								/* Dailog Procedures				*/
								/************************************************/

									/****************************************/
									/* Dialog Service - Load		*/
									/****************************************/

int combo_load() {
	ComboBoxAddItem(CB_COMBO_BOX, "Item 1 - Cats");
	ComboBoxAddItem(CB_COMBO_BOX, "Item 2 - Dogs");
	ComboBoxAddItem(CB_COMBO_BOX, "Item 3 - Ferrets");
	ComboBoxAddItem(CB_COMBO_BOX, "Item 4 - Mouses");
	combo_update();
    	}
        
									/****************************************/
									/* Dialog Service - Action		*/
									/****************************************/
int combo_action(int c_id, int c_ac) {
    	string		s1;
        int		rc;


	if (c_id == CB_COMBO_BOX) {					// List Box
	  if (c_ac == 1) {
	    combo_update();
	    }          
	  return 0;
          }
	if (c_id == CB_RESET) {						// Reset
          ComboBoxReset(CB_COMBO_BOX);
	  combo_update();
	  return 0;
          }
	if (c_id == CB_INSERT) {					// Insert
          ComboBoxInsertItem(CB_COMBO_BOX, 1, "Inserted at Position 1");
	  combo_update();
	  return 0;
          }
	if (c_id == CB_DELETE) {					// Delete
	  s_ix = ComboBoxGetSelectIndex(CB_COMBO_BOX);
	  if (s_ix < 0) {
            MessageBox('X', "Nothing selected");
            }
          ComboBoxDeleteItem(CB_COMBO_BOX, s_ix);
	  combo_update();
	  return 0;
          }
	if (c_id == CB_SELECT) {					// Select
	  s1 = DialogGetCaption();
	  MessageBox('i', "Caption:\r\r%s", s1);
          ComboBoxSelectItem(CB_COMBO_BOX, s_ix);
	  s_ix++;
	  combo_update();
	  return 0;
          }
	if (c_id == CB_SELECT_RESET) {					// Select Reset
	  s_ix = -1;
          ComboBoxSelectItem(CB_COMBO_BOX, s_ix);
	  combo_update();
	  return 0;
          }
    	}

									/****************************************/
									/* Dialog Support 			*/
									/****************************************/
int combo_update() {
	string		s1;
	int		ix, ic;

	ix = ComboBoxGetSelectIndex(CB_COMBO_BOX);
	ic = ComboBoxGetItemCount(CB_COMBO_BOX);
        if (ix < 0) {
          EditSetText(CB_INDEX, "(not selected)");
	  EditSetText(CB_CONTENT, "(no data)");
	  ControlDisable(CB_DELETE);
          }
        else {
          EditSetText(CB_INDEX, ix);
	  s1 = ComboBoxGetItemText(CB_COMBO_BOX, ix);
	  EditSetText(CB_CONTENT, s1);
	  ControlEnable(CB_DELETE);
          }
        EditSetText(CB_TOTAL, ic);
    	}
